unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Character, ExtCtrls, ComCtrls, World, Buttons, DXDraws,
  DXClass, Tiles, DXInput, DIB;


type
  TForm1 = class(TForm)
    ImgLst: TDXImageList;
    DXT: TDXTimer;
    DXDraw: TDXDraw;
    TileLst: TDXImageList;
    DXInput: TDXInput;
    procedure FormCreate(Sender: TObject);
    procedure BtClick(Sender: TObject);
    procedure DXTTimer(Sender: TObject; LagCount: Integer);
  private
    procedure ShowParameters;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Ch: TCharacter;
  Wr: TWorld;

implementation

{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  Wr := TWorld.Create;
  if not Wr.LoadMap(ExtractFilePath(Application.ExeName) + 'level') then
    Exit;
  Ch := TCharacter.Create(Wr, 46 - 16, 60 - 12, 100, 100);

  //Ucitaj tiles is Wr.Tiles u ImgLst kontrolu
  for I := 0 to Wr.Tiles.Tilecount - 1 do
  begin
    TileLst.Items[I].Picture.Bitmap.Assign(Wr.Tiles.GetBitmap(I));
    TileLst.Items[I].Restore;
  end;
  Wr.Tiles.FreeBitmaps;

  //Dodeli tastere za Run i Jump
  DXInput.Keyboard.KeyAssigns[isButton1, 0] := VK_SHIFT;
  DXInput.Keyboard.KeyAssigns[isButton2, 0] := Ord('Z');;

  DXT.Enabled := True;
end;

procedure TForm1.ShowParameters;
begin
  with DXDraw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    FOnt.Name := 'Terminal';
    Font.Color := clBlack;
    Font.Style := [];
    Font.Size := 12;
    Textout(0, 0,   'X    = ' + FormatFloat(' ,000.0;-,000.0 ', Ch.X));
    Textout(0, 20,  'Y    = ' + FormatFloat(' ,000.0;-,000.0 ', Ch.Y));
    Textout(0, 40,  'Vx   = ' + FormatFloat(' ,000.0;-,000.0 ', Ch.Vx));
    Textout(0, 60,  'Vy   = ' + FormatFloat(' ,000.0;-,000.0 ', Ch.Vy));
    Release;
  end;
end;

procedure TForm1.DXTTimer(Sender: TObject; LagCount: Integer);
var
  I, J: Integer;
  R: TRect;
begin
  R.Left := 0;
  R.Top := 0;
  R.Bottom := 63;
  R.Right:= 63;

  DXInput.Update;

  if isUp in DXInput.States then
    Ch.GoUp
  else
    Ch.StopUp;
  if isDown in DXInput.States then
    Ch.GoDown
  else
    Ch.StopDown;
  if isLeft in DXInput.States then
    Ch.GoLeft
  else
    Ch.StopLeft;
  if isRight in DXInput.States then
    Ch.GoRight
  else
    Ch.StopRight;
  if isButton1 in DXInput.States then
    Ch.GoRun
  else
    Ch.StopRun;
  if isButton2 in DXInput.States then
    Ch.GoJump
  else
    Ch.StopJump;

  Ch.Tick;
  if not DXDraw.CanDraw then Exit;

  DXDraw.Surface.Fill($777799);
  for I := 0 to 15 do
    for J := 0 to 11 do
      TileLst.Items[Wr.Levelmap[I, J]].Draw(DXDraw.Surface, I * TileWidth , J * TileHeight, 0);
  ImgLst.Items[Ch.GetFrameIndex].Draw(DXDraw.Surface, Ch.X - 8 , Ch.Y - 6, 0);
  with DXDraw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clBlack;
    Font.Name := 'Tahoma';
    Font.Size := 14;
    Font.Style := [fsBold];
    Textout(700, 10, 'Super Stojadin v0.000002');
    Release;
  end;
  ShowParameters;
  DXDraw.Flip;
end;

procedure TForm1.BtClick(Sender: TObject);
var
  F: file of TLevelData;
  T: TLevelData;
begin
  AssignFile(F, 'c:\level.lvm');
  Rewrite(F, 'c:\level.lvm');
  T.WidthTiles := 16;
  T.HeightTiles := 12;
  T.TLRFile := 'level.tlr';
  Write(F, T);
  CloseFile(F);
end;


end.

